Subject: Re: [PATCH] [ETHTOOL]: Add support for large eeproms

From: Mandeep Singh Baines <[email-masked]>
Date: Tue, 15 Apr 2008 10:39:31 -0700

David Miller ([email-masked]) wrote:
> From: Mandeep Singh Baines <[email-masked]>
> Date: Mon, 14 Apr 2008 11:03:38 -0700
> 
> > Currently, it is not possible to read/write to an eeprom larger than
> > 128k in size because the buffer used for temporarily storing the
> > eeprom contents is allocated using kmalloc. kmalloc can only allocate
> > a maximum of 128k depending on architecture.
> > 
> > Modified ethtool_get/set_eeprom to only allocate a page of memory and
> > then copy the eeprom a page at a time.
> > 
> > Updated original patch as per suggestions from Joe Perches.
> > 
> > Signed-off-by: Mandeep Singh Baines <[email-masked]>
> 
> This looks fine on the surface.
> 
> But I wonder what we can do if we have some EEPROM implementation
> that can only write the whole time at once, and thus will fail
> if you try to do it in pieces?  Do we have such a case?
> 

I suspect such a case does not exist but can't say for certain. Currently,
the only user-space application I'm aware of which makes use of the set_eeprom
ioctl interface is ethtool. It currently only supports single byte writes.
Hence, any device which supports set_eeprom will likely also support
single byte writing.

To test my changes, I had to modify the ethtool application to support writing
an arbitrary number of bytes to eeprom. This makes it possible to update an
eeprom from a binary file. To do so, I use ethtool as follows:

# ethtool -E eth1 < eeprom.bin

I plan on sending my ethtool changes to the maintainers once this patch
is accepted.

> If so this new code could cause regressions.

An alternative would be to vmalloc the entire size to avoid the potential
regression.